package net.t2code.commandguiv2.Spigot.config.languages;

import net.t2code.commandguiv2.Spigot.Main;
import net.t2code.commandguiv2.Spigot.config.config.SelectConfig;
import net.t2code.commandguiv2.Util;
import net.t2code.t2codelib.SPIGOT.api.messages.T2Creplace;
import net.t2code.t2codelib.SPIGOT.api.messages.T2Csend;
import org.bukkit.configuration.file.YamlConfiguration;

import java.io.File;
import java.util.Objects;

public class SelectMessages {


    public static String selectMSG;

    public static String VaultNotSetUp;
    public static String SoundNotFound;
    public static String OnlyForPlayer;
    public static String DefaultGUIcreate;
    public static String ReloadStart;
    public static String ReloadEnd;

    public static String NoPermission;
    public static String NoPermissionForCommand;
    public static String NoPermissionForUseItem;
    public static String NoPermissionForItem;

    public static String ItemON;
    public static String ItemOFF;
    public static String ItemSlot;
    public static String ItemSlotNotEmpty;
    public static String ItemSlotAlreadySet;
    public static String ItemSlot_wrongValue;
    public static String UseItemDisabledInGameMode;
    public static String UseItemDisabledInWorld;

    public static String Buy_msg;
    public static String noMoney;
    public static String noMoneyItem;
    public static String noMoneyVote;
    public static String NoInventorySpace;

    public static String onServerChange;

    public static String guiNotFound;
    public static String GUIIsDisabled;

    public static String Give_Sender;
    public static String Give_Receiver;

    public static String PlayerNotFond;
    public static String PlayerNoInventorySpace;

    public static String functionItemAdd;
    public static String functionItemRemove;
    public static String functionItemRemoveError;
    public static String functionVoteAdd;
    public static String functionVoteRemove;
    public static String functionVoteRemoveError;

    public static String HelpCgui;
    public static String HelpHelp;
    public static String HelpInfo;
    public static String HelpOpen;
    public static String HelpGive;
    public static String HelpCreateDefaultGUI;
    public static String HelpReload;
    public static String GUIItemHelp_on;
    public static String GUIItemHelp_off;
    public static String GUIItemHelp_Slot;
    public static String PlayerHelpCgui;
    public static String PlayerHelpHelp;
    public static String PlayerHelpInfo;
    public static String PlayerHelpOpen;
    public static String PlayerHelpGive;
    public static String PlayerHelpCreateDefaultGUI;
    public static String PlayerHelpReload;
    public static String PlayerGUIItemHelp_on;
    public static String PlayerGUIItemHelp_off;
    public static String PlayerGUIItemHelp_Slot;

    public static void onSelect(String Prefix) {
        T2Csend.debug(Main.getPlugin(), "§4Select language...");
        long long_ = System.currentTimeMillis();

        File msg;

        msg = new File(Main.getPath(), "languages/" + SelectConfig.getLanguage() + "_messages.yml");
        if (!msg.isFile()) {
            T2Csend.console(Prefix);
            T2Csend.console(Prefix + " §4!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!");
            T2Csend.console(Prefix + " §4The selected §c" + SelectConfig.getLanguage() + " §4language file was not found.");
            T2Csend.console(Prefix + " §6The default language §eEnglish §6is used!");
            T2Csend.console(Prefix + " §4!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!");
            T2Csend.console(Prefix);
            msg = new File(Main.getPath(), "languages/" + "english_messages.yml");
            selectMSG = "english";
        } else selectMSG = SelectConfig.getLanguage();
        YamlConfiguration yamlConfiguration_msg = YamlConfiguration.loadConfiguration(msg);

        VaultNotSetUp = select("Plugin.VaultNotSetUp", yamlConfiguration_msg);
        SoundNotFound = select("Plugin.SoundNotFound", yamlConfiguration_msg);
        OnlyForPlayer = select("Plugin.OnlyForPlayer", yamlConfiguration_msg);
        DefaultGUIcreate = select("Plugin.DefaultGUI.create", yamlConfiguration_msg);
        ReloadStart = select("Plugin.Reload.Start", yamlConfiguration_msg);
        ReloadEnd = select("Plugin.Reload.End", yamlConfiguration_msg);

        NoPermission = select("NoPermission.ForCommandGUI", yamlConfiguration_msg);
        NoPermissionForCommand = select("NoPermission.ForCommand", yamlConfiguration_msg);
        NoPermissionForUseItem = select("NoPermission.ForUseItem", yamlConfiguration_msg);
        NoPermissionForItem = select("NoPermission.ForItem", yamlConfiguration_msg);

        ItemON = select("UseItem.UseItem_ON", yamlConfiguration_msg);
        ItemOFF = select("UseItem.UseItem_OFF", yamlConfiguration_msg);
        ItemSlot = select("UseItem.Change_Slot", yamlConfiguration_msg);
        ItemSlotNotEmpty = select("UseItem.SlotNotEmpty", yamlConfiguration_msg);
        ItemSlotAlreadySet = select("UseItem.SlotAlreadySet", yamlConfiguration_msg);
        ItemSlot_wrongValue = select("UseItem.ItemSlot_wrongValue", yamlConfiguration_msg);
        UseItemDisabledInGameMode = select("UseItem.DisabledInGameMode", yamlConfiguration_msg);
        UseItemDisabledInWorld = select("UseItem.DisabledInWorld", yamlConfiguration_msg);

        Buy_msg = select("Cost.Buy_msg", yamlConfiguration_msg);
        noMoney = select("Cost.No.Money", yamlConfiguration_msg);
        noMoneyItem = select("Cost.No.Item", yamlConfiguration_msg);
        noMoneyVote = select("Cost.No.Vote", yamlConfiguration_msg);

        NoInventorySpace = select("Cost.NoInventorySpace", yamlConfiguration_msg);

        onServerChange = select("ServerChange.onServerChange", yamlConfiguration_msg);

        guiNotFound = select("GUI.GUInotFound", yamlConfiguration_msg);
        GUIIsDisabled = select("GUI.GUIisDisabled", yamlConfiguration_msg);

        Give_Sender = select("Give.Sender", yamlConfiguration_msg);
        Give_Receiver = select("Give.Receiver", yamlConfiguration_msg);

        PlayerNotFond = select("Player.PlayerNotFond", yamlConfiguration_msg);
        PlayerNoInventorySpace = select("Player.PlayerNoInventorySpace", yamlConfiguration_msg);

        functionItemAdd = select("FunctionItem.Add", yamlConfiguration_msg);
        functionItemRemove = select("FunctionItem.Remove", yamlConfiguration_msg);
        functionItemRemoveError = select("FunctionItem.RemoveError", yamlConfiguration_msg);

        functionVoteAdd = select("FunctionVote.Add", yamlConfiguration_msg);
        functionVoteRemove = select("FunctionVote.Remove", yamlConfiguration_msg);
        functionVoteRemoveError = select("FunctionVote.RemoveError", yamlConfiguration_msg);

        HelpCgui = select("Help.CGUI", yamlConfiguration_msg);
        HelpHelp = select("Help.Help", yamlConfiguration_msg);
        HelpInfo = select("Help.Info", yamlConfiguration_msg);
        HelpOpen = select("Help.Open", yamlConfiguration_msg);
        HelpGive = select("Help.Give", yamlConfiguration_msg);
        HelpCreateDefaultGUI = select("Help.CreateDefaultGUI", yamlConfiguration_msg);
        HelpReload = select("Help.Reload", yamlConfiguration_msg);
        GUIItemHelp_on = select("Help.UseItem_On", yamlConfiguration_msg);
        GUIItemHelp_off = select("Help.UseItem_Off", yamlConfiguration_msg);
        GUIItemHelp_Slot = select("Help.UseItem_Slot", yamlConfiguration_msg);

        PlayerHelpCgui = select("Help.Player.CGUI", yamlConfiguration_msg);
        PlayerHelpHelp = select("Help.Player.Help", yamlConfiguration_msg);
        PlayerHelpInfo = select("Help.Player.Info", yamlConfiguration_msg);
        PlayerHelpOpen = select("Help.Player.Open", yamlConfiguration_msg);
        PlayerHelpGive = select("Help.Player.Give", yamlConfiguration_msg);
        PlayerHelpCreateDefaultGUI = select("Help.Player.CreateDefaultGUI", yamlConfiguration_msg);
        PlayerHelpReload = select("Help.Player.Reload", yamlConfiguration_msg);
        PlayerGUIItemHelp_on = select("Help.Player.UseItem_On", yamlConfiguration_msg);
        PlayerGUIItemHelp_off = select("Help.Player.UseItem_Off", yamlConfiguration_msg);
        PlayerGUIItemHelp_Slot = select("Help.Player.UseItem_Slot", yamlConfiguration_msg);


        T2Csend.console(Prefix + " §2Language successfully selected to: §6" + selectMSG + " §7- §e" + (System.currentTimeMillis() - long_) + "ms");
    }

    private static String select(String path, YamlConfiguration yamlConfiguration) {
        return T2Creplace.replace(Util.getPrefix(), Objects.requireNonNull(yamlConfiguration.getString(path)));
    }
}
